/*  dictionary.c - creates a dictionary object with 3 methods.
 *  Copyright (C) 2009 Henry Kroll, www.thenerdshow.com
 * 
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define FIN return 0;

#define BYTES 99
/* This is a dictionary object. The following methods are available:
 *    add()      adds a word or phrase to the dictionary
 *    print()	 prints a word or phrase from the dictionary
 *    destroy()  destroys the dictionary
 */
#define D dictionary
#define dictionary_add(xx,yy) 	if(D(xx))strncpy(D(xx),yy,BYTES); \
								else fprintf(stderr,"memory error\n");
#define dictionary_print(xx) 	puts(D(xx))
#define dictionary_destroy()	D("destroy()")
char *dictionary(char *wrd){	typedef struct lookup *plookup;
	struct lookup { char *k,*v; plookup next; };int size=strlen(wrd);
	static int ready=0; static plookup a,b,p;
	if(ready){if(!strcmp(wrd,"destroy()")){//destroy()
		for(a=p;a;a=b)free(a->v),free(a->k),b=a->next,free(a);ready=0;return "";
		} else for(a=p;a;b=a,a=a->next)if(!strcmp(a->k,wrd))return a->v;//search()
	} if (!((a=malloc(sizeof p))&&(a->k=malloc(size+1))&&(a->v=malloc(BYTES+1))))
		return NULL; //out of memory
	a->next=NULL;strcpy(a->k,wrd);strcpy(a->v,"no entry");//add()
	if(!ready)ready=1,p=a;//init()
	else b->next=a;	return a->v;//return a pointer to the 100 bytes of storage
}

int main (){
	char *definition;
	char word[80]="explain";
	//we can assign using strcpy or by using the add() method
	dictionary_add(word,"Just use the add method.");
	dictionary_add("about",	"Adding words to the dictionary is easy.");
	dictionary_add("welcome","Welcome to the friendly dictionary.");
	
	
	//one way to print from the dictionary
	puts(dictionary("welcome"));
	//another way to print from the dictionary
	dictionary_print("about");
	//yet more ways of getting data from the dictionary
	strcpy(word,"explain");
	definition=dictionary(word);puts(definition);
	strcpy(word,dictionary(word));
	dictionary_add(word,"foo");
	dictionary_print("Just use the add method.");//prints foo
	
	dictionary_destroy();	//erase the dictionary and start over
	dictionary_print("welcome");//now it says no entry
	dictionary_destroy();
	FIN;
}
/* Terminal run:

>make
gcc -g -Wextra -Wall -pedantic -std=c99 -c dictionary.c -o dictionary.o
gcc dictionary.o -o dictionary 
>Exit code: 0

>./"dictionary"
Welcome to the friendly dictionary.
Adding words to the dictionary is easy.
Just use the add method.
no entry
>Exit code: 0
*/
